#include	<string>
#include	<vector>
#include	<map>
#include	<fltk/dirent.h>
#include	<iostream>
#include	<fstream>

using	namespace	std;

class	GeoMaterialLoader
{
	private:

		//	Directory path.
		string	mMatPath;
		string	mTexPath;
		
		//	List of files.
		vector<string>	mFiles;
		
		//	Mat of materials and textures.
		map<string,string>	mMatMap;
		
		//	Load material.
		void	load();
		
		//	Search material files.
		void	search(string	path);
		
	public:

		///	Constructor.
		GeoMaterialLoader();

		///	Destroyer.
		~GeoMaterialLoader();
		
		//	Check if material name exists.
		bool	existsMaterial(string	matName);

		//	Gets texture filename of the material.
		string	getTextureFileName(string	matName);
};
